////////////////////////////////////////////////////////////////////////////////
//:   2  : " 
//"   
//:  Ը 
//:  http://www.DXGames.narod.ru
//e-mail: UrvanovF@hotmail.ru
////////////////////////////////////////////////////////////////////////////////
unit Main;

interface

uses
  SysUtils, Types, Classes, Variants, QTypes, QGraphics, QControls, QForms,
  QDialogs, QStdCtrls, QMenus, QGrids, QDBGrids,About;
const MEMORY_SIZE=10;
    cIF=1;
    cID=2;
    cEX=3;
    cMEM=4;
    cWB=5;

type
  EToManyConstOperands=class(Exception);
  TCommand=(cLW,cSW,cMOV,cADD,cSUB,cMUL,cDIV,cAND,cOR,cXOR,cNOT,cNOP,cMAX);
  TNonAssembledCommand=class
  public
    Command:TCommand;
    Operands:array[1..3] of integer;
    WhoConst:integer;//  Operand1,Operand2,Operand3  
    CountOfOperands:integer;
    strCommand:String;
    procedure SetCommand(const Str1:string);
    procedure SetOperand(Index:integer;const S:string);
  end;

  TfrmMain = class(TForm)
    lblConveyor: TLabel;
    lblRegisters: TLabel;
    lblMemory: TLabel;
    lblParameters: TLabel;
    memProgram: TMemo;
    lblProgram: TLabel;
    sgConveyor: TStringGrid;
    sgRegisters: TStringGrid;
    sgMemory: TStringGrid;
    sgParameters: TStringGrid;
    MainMenu1: TMainMenu;
    N1: TMenuItem;
    Open: TMenuItem;
    Run: TMenuItem;
    Step: TMenuItem;
    N2: TMenuItem;
    About: TMenuItem;
    OpenDialog1: TOpenDialog;
    DoCompile: TMenuItem;
    Exit: TMenuItem;
    procedure FormActivate(Sender: TObject);
    procedure OpenClick(Sender: TObject);
    procedure StepClick(Sender: TObject);
    procedure AboutClick(Sender: TObject);
    procedure RunClick(Sender: TObject);
    procedure DoCompileClick(Sender: TObject);
  private
    { Private declarations }
    Memory:array [0..MEMORY_SIZE] of integer;
    Registers:array [0..7] of integer;
    Conveyor:array [1..5] of integer;//  ,  
    Commands:array of TNonAssembledCommand;
    Takt:integer;
    varsID,varsEX,varsMEM,varsWB:array [1..3] of integer;
    IFBusy,IDBusy,EXBusy,MEMBusy,WBBusy:integer;// ,    1 
    CommandCounter:integer;//  
    ProgramOver:boolean;
    EXjumperEX:boolean;// ,    EX-EX
    IDDelay:boolean;// ,      ID
    procedure Compile;
    procedure DoTakt;
    procedure DoIF;
    procedure DoID;
    procedure DoEX;
    procedure DoMEM;
    Procedure DoWB;
    procedure CalculateCharacteristics;
  public
    { Public declarations }
  end;

var
  frmMain: TfrmMain;
  CommandStrings:array [0..integer(cMAX)] of string;

implementation

{$R *.xfm}

procedure TfrmMain.FormActivate(Sender: TObject);
var n:integer;
begin
  sgConveyor.Cells[0,0]:='';
  sgConveyor.Cells[1,0]:='';
  sgConveyor.Cells[2,0]:='';
   sgConveyor.Cells[0,1]:='IF';
  sgConveyor.Cells[0,2]:='ID';
  sgConveyor.Cells[0,3]:='EX';
  sgConveyor.Cells[0,4]:='MEM';
  sgConveyor.Cells[0,5]:='WB';
  sgConveyor.Cells[2,1]:='  ( ,   ,    )';
  sgConveyor.Cells[2,2]:='      ,  .';
  sgConveyor.Cells[2,3]:='      ,       .';
  sgConveyor.Cells[2,4]:='     SW  LW.';
  sgConveyor.Cells[2,5]:='      .';
  for n:=1 to 8 do
  begin
    sgRegisters.Cells[0,n]:='r'+IntToStr(n-1);
    sgRegisters.Cells[1,n]:='0';
  end;
  sgRegisters.Cells[0,0]:='';
  sgRegisters.Cells[1,0]:='';

  sgMemory.RowCount:=MEMORY_SIZE+1;
  for n:=1 to MEMORY_SIZE do
  begin
    sgMemory.Cells[0,n]:=IntToStr(n-1);
    sgMemory.Cells[1,n]:='0';
  end;
  sgMemory.Cells[0,0]:='';
  sgMemory.Cells[1,0]:='';


  for n:=0 to MEMORY_SIZE do
  begin
    Memory[n]:=0;
  end;

  CommandStrings[integer(cLW)]:='LW';
  CommandStrings[integer(cSW)]:='SW';
  CommandStrings[integer(cMOV)]:='MOV';
  CommandStrings[integer(cADD)]:='ADD';
  CommandStrings[integer(cSUB)]:='SUB';
  CommandStrings[integer(cMUL)]:='MUL';
  CommandStrings[integer(cDIV)]:='DIV';
  CommandStrings[integer(cAND)]:='AND';
  CommandStrings[integer(cOR)]:='OR';
  CommandStrings[integer(cXOR)]:='XOR';
  CommandStrings[integer(cNOT)]:='NOT';
  CommandStrings[integer(cNOP)]:='NOP';




  for n:=0 to 7 do
  begin
    Registers[n]:=0;
  end;

  sgParameters.Cells[0,1]:='';
  sgParameters.Cells[0,2]:=' ';
  sgParameters.Cells[0,3]:=' ';
  sgParameters.Cells[0,4]:=' ';
  sgParameters.Cells[0,5]:='-    -';
  sgParameters.Cells[0,6]:=' ';

end;

procedure TfrmMain.OpenClick(Sender: TObject);
var InputFile: TextFile;
  Str1:String;
  n:integer;
begin
  OpenDialog1.Execute;
  AssignFile(InputFile,OpenDialog1.FileName);
  Reset(InputFile);
  memProgram.Lines.Clear;
  while not eof(InputFile)  do
  begin
    readln(InputFile,Str1);
    memProgram.Lines.Add(Str1);
  end;
  CloseFile(InputFile);
  Compile;
end;


procedure TfrmMain.Compile;
var Str1:String;
  n:integer;
  t:integer;
begin
  for n:=1 to 6 do
  begin
    sgParameters.cells[1,n]:='';
  end;
  
  for n:=0 to memProgram.Lines.Count-1 do
  begin
    Str1:=memProgram.Lines[n];
    SetLength(Commands,n+2);
    Commands[n+1]:=TNonASsembledCommand.Create  ;
    Commands[n+1].SetCommand(Str1);
  end;
  t:=0;
  for n:=1 to Length(Commands)-1 do
  begin
    case Commands[n].Command of
    cMUL,cDIV:Inc(t,7);
    else Inc(t,5);
    end;
  end;
  sgParameters.Cells[1,5]:=IntToStr(t);

  //   (-1)
  //           -1
  // ,  ,     ()
  IFBusy:=-1;
  IDBusy:=-1;
  EXBusy:=-1;
  MEMBusy:=-1;
  WBBusy:=-1;

  for n:=1 to 5 do
  begin
    Conveyor[n]:=0;
  end;

  CommandCounter:=0;
  Takt:=0;
  ProgramOver:=false;
end;

procedure TNonAssembledCommand.SetCommand(const Str1:string);
var n:integer;
  Sc:String;
   s,e:integer;//    
  l,k:integer;
begin

   l:=length(Str1);
   strCommand:=Str1;
    s:=1;
    while Str1[s]=' ' do Inc(s);
    e:=s;
    while (Str1[e]<>' ') and (e<l) do Inc(e);

    Sc:=copy(str1,s,e-s);
    for n:=0 to integer(cMAX) do
    begin
      if CommandStrings[n]=Sc Then Command:=TCommand(n);
    end;
    //     
    case Command of
      cNOP:begin CountOfOperands:=0;end;
      cLW,cSW,cMOV:begin CountOfOperands:=2; end;
      cNOT: begin CountOfOperands:=1; end;
      cADD,cSUB,cMUL,cDIV,cAND, cOR,cXOR:begin CountOfOperands:=3;end;
    end;
    k:=0;
    while e<=l do
    begin
      Inc(k);
      s:=e;
      while (Str1[s]=' ') and (s<=l) do Inc(s);
      e:=s;
      while ((Str1[e]<>' ')and (Str1[e]<>',') )and (e<=l) do Inc(e);
      if (s=e) Then break;
      SetOperand(k,Copy(Str1,s,e-s));
    end;
end;

procedure TNonAssembledCommand.SetOperand(Index:integer;const S:string);

begin
  if (S[1]='R') Then
  begin
    Operands[Index]:=StrToInt(Copy(S,2,1));
  end
  else
  begin
    if WhoConst>0 Then raise EToManyConstOperands.Create('Must be only 1 const operand.');
    WhoConst:=Index;
    Operands[Index]:=StrToInt(S);
  end;
end;


procedure TfrmMain.StepClick(Sender: TObject);
begin
  DoTakt;
end;

procedure TfrmMain.DoTakt;
var n:integer;
begin

    for n:=0 to 7 do
    begin
      sgRegisters.cells[1,n+1]:=IntToStr(Registers[n]);
    end;
    for n:=0 to MEMORY_SIZE do
    begin
      sgMemory.Cells[1,n+1]:=IntToStr(Memory[n]);
    end;
    //  
    sgParameters.Cells[1,1]:=IntToStr(Takt);
    sgParameters.Cells[1,2]:=IntToStr(CommandCounter);
   if not ProgramOver Then
    begin
    Inc(Takt);
    DoWB;
    DoMEM;
    DoEX;
    DoID;
    DoIF;
    for n:=1 to 5 do
    begin
      if (Conveyor[n]>0) and (Conveyor[n]<Length(Commands)) Then
        sgConveyor.Cells[1,n]:=Commands[Conveyor[n]].strCommand
      else
        sgConveyor.Cells[1,n]:='';
    end;


    if (EXjumperEX) Then
    begin
      sgParameters.Cells[1,3]:='  ';
      sgParameters.Cells[1,4]:=' EX-EX';
      EXjumperEX:=false;
    end
    else
    begin
      if IDDelay Then
      begin
        sgParameters.Cells[1,3]:='  ';
        sgParameters.Cells[1,4]:=' ';

      end
      else
      begin
        if ((IFBusy<>-1) or (IDBusy<>-1) or (EXBusy<>-1) or (MEMBusy<>-1)
         or (WBBusy<>-1)) Then
         begin
          sgParameters.Cells[1,3]:=' ';
          sgParameters.Cells[1,4]:=' ';
         end
         else
         begin
          sgParameters.Cells[1,3]:='';
          sgParameters.Cells[1,4]:='';
         end;
      end //IDDelay
    end;

    if ProgramOver Then
    begin
      CalculateCharacteristics;
    end;
  end;// not ProgramOver
end;



Procedure TfrmMain.DoIF;
begin
 if (IFBusy=-1) Then
 begin
    if (IDBusy<>-1) Then IFBusy:=1;
    Conveyor[1]:=CommandCounter;
    Inc(CommandCounter);
  end
  else
  begin
    if (IDBusy=-1) Then   IFBusy:=-1;
  end;
  //if Length(Commands)>Conveyor[1] and Conveyor[1]>0 Then
  //  sgConveyor.Cells[1,1]:=Commands[Conveyor[1]].strCommand
  //else
  //begin
  //  sgConveyor.Cells[1,1]:='';
  //end;
end;

procedure TfrmMain.DoID;
  var n,k:integer;
  Command:^TNonAssembledCommand;
  EXCommand,MEMCommand:^TNonAssembledCommand;//    
begin

  if ((EXBusy<>-1) and (IDBusy=-1)) Then
  begin
    IDBusy:=EXBusy;
    if (Conveyor[cID]=Conveyor[cEX]) Then Conveyor[cID]:= Conveyor[cIF]
  end;
  if (IDBusy=-1) Then
    Conveyor[cID]:= Conveyor[cIF];

    if (Conveyor[cID]>0) and (Conveyor[cID]<Length(Commands)) Then
    begin
      if (IDBusy>0) Then
           Dec(IDbusy)
      else
      begin


      if (IDBusy=0) Then begin IDBusy:=-1;IDDelay:=false; end;
      Command:=@Commands[Conveyor[cID]];

      if (Conveyor[cEX]>0) and (Conveyor[cEX]<Length(Commands))Then
        EXCommand:=@Commands[Conveyor[cEX]]
      else
        EXCommand:=NIL;
      if (Conveyor[cMEM]>0) and (Conveyor[cMEM]<Length(Commands))Then
        MEMCommand:=@Commands[Conveyor[cMEM]]
      else
        MEMCommand:=NIL;

      k:=Command.CountOfOperands;
      for n:=1 to k do
      begin

        if (Command^.WhoConst=n) Then varsID[Command^.WhoConst]:=Command^.Operands[n]
        else
        begin
          varsID[n]:=Registers[Command^.Operands[n]];
          if (EXCommand<>NIL) then
          begin
            if ((EXCommand^.Command=cLW) and (EXCommand^.Operands[1]=Command^.Operands[n])) Then
            begin
              IDBusy:=2;
              IDDelay:=true;
            end;
          end;
          if (MEMCommand<>NIL) then
          begin
            if ((MEMCommand^.Command=cLW) and (MEMCommand^.Operands[1]=Command^.Operands[n])) Then
            begin
              IDBusy:=1;
              IDDelay:=true;
            end;
          end;
        end;
      end;
      end;//
    end;
end;

procedure TfrmMain.DoEX;
var n,k:integer;
 Command:^TNonAssembledCommand;
 MEMCommand:^TNonAssembledCommand;
begin
  if (EXBusy=-1) Then
  begin
    if (IDBusy=-1) Then
    begin
      Conveyor[cEX]:=Conveyor[cID];
      if (Conveyor[cMEM]>0) and (Conveyor[cMEM]<Length(Commands)) Then
        MEMCommand:=@Commands[Conveyor[cMEM]]
      else
        MEMCommand:=NIL;
      k:=3;
      if (Conveyor[cEX]>0) and (Conveyor[cEX]<Length(Commands)) Then
      begin
        k:=Commands[Conveyor[cEX]].CountOfOperands;
        for n:=1 to k do
        begin
          varsEX[n]:=varsID[n];
          if (MEMCOmmand<>NIL) Then
          begin
            case MEMCommand.Command of
              cADD,cSUB,cMUL,cDIV,cAND,cOR,cXOR,cNOT:
              begin
               if (Commands[Conveyor[cEX]].WhoConst<>n) and (n<>1) Then
               begin
                   if (Commands[Conveyor[cEX]].Operands[n]=MEMCommand.Operands[1]) Then
                   begin
                    // 
                    varsEX[n]:=varsMEM[1];
                    EXjumperEX:=true;
                   end;
               end;
              end;
              cMOV:
              begin
                if (MEMCommand.WhoConst=2) Then
                begin
                   if (Commands[Conveyor[cEX]].Operands[n]=MEMCommand.Operands[1]) then
                   begin
                     varsEX[n]:=varsMEM[2];
                     EXjumperEX:=true;
                   end;
                end
              end;
            end;
          end;//if MEMCommand<>NIL
        end;//for
      end;//if Conveyor[cEX]>0.....  
    end
    else
    begin
      Conveyor[cEX]:=0;
    end;
  end;//if EXBusy=-1

  if (Conveyor[cEX]>0) and (Conveyor[cEX]<Length(Commands)) Then
  begin
    Command:=@Commands[Conveyor[cEx]];
    case Command.Command of
      cADD:
      begin
        varsEX[1]:=varsEX[2]+varsEX[3];
      end;
      cMOV:
      begin
        varsEX[1]:=varsEX[2];
      end;
      cSUB:
      begin
        varsEX[1]:=varsEX[2]-varsEX[3];
      end;
      cMUL:
      begin
        if (EXBusy=-1) then EXBusy:=3;
        Dec(EXBusy);
        if (EXBusy=0) Then
        begin
          EXBusy:=-1;
          varsEX[1]:=varsEX[2]*varsEX[3];
        end;
      end;
      cDIV:
      begin
        if (EXBusy=-1) then EXBusy:=3;
        Dec(EXBusy);
        if (EXBusy=0) Then
        begin
          EXBusy:=-1;
          varsEX[1]:=varsEX[2] DIV varsEX[3];
        end;
      end;
      cAND:
      begin
        varsEX[1]:=varsEX[2] and varsEX[3];
      end;
      cOR:
      begin
        varsEX[1]:=varsEX[2] or varsEX[3];
      end;
      cXOR:
      begin
        varsEX[1]:=varsEx[2] xor varsEX[3];
      end;
      cNOT:
      begin
        varsEX[1]:= NOT varsEX[1];
        //    !!!!!!!!!!!!!!!!!!!!!!!
      end;
      //  NOP, LW, SW   EX    .
    end;//end case
  end;

end;

procedure TfrmMain.DoMEM;
var n:integer;
 Command:^TNonAssembledCommand;
begin
  //,      ,    
  if (EXBusy=-1) Then
  begin
    MEMBusy:=-1;
    Conveyor[cMEM]:=Conveyor[cEX];
    for n:=1 to 3 do
      varsMEM[n]:=varsEX[n];
    if (Conveyor[cMEM]>0) and (Conveyor[cMEM]<Length(Commands)) Then
    begin
      Command:=@Commands[Conveyor[cMEM]];
      case Command.Command of
      cLW:
      begin
        {Registers[varsMEM[1]]:=Memory[varsMEM[2]] shl 24 + Memory[varsMEM[2]+1] shl 16 + Memory[varsMEM[2]+2] shl 8 + Memory[varsMEM[2]+3];}
        Registers[varsMEM[1]]:=Memory[varsMEM[2]];
      end;
      cSW:
      begin
        {Memory[varsMEM[1]]:=byte(Registers[varsMEM[2]]shr 24);
        Memory[varsMEM[1]+1]:=byte(Registers[varsMEM[2]]shr 16);
        Memory[varsMEM[1]+2]:=byte(Registers[varsMEM[2]]shr 8);
        Memory[varsMEM[1]+3]:=byte(Registers[varsMEM[2]]);}
        Memory[varsMEM[1]]:=Registers[varsMEM[2]];
      end;
      end;
    end;
  end
  else
  begin
    MEMbusy:=1;
    Conveyor[cMEM]:=0;
  end;
end;

procedure TfrmMain.DoWB;
var n:integer;
 Command:^TNonAssembledCommand;
begin
  if (MEMBusy=-1) Then
  begin
    WBBusy:=-1;
    Conveyor[cWB]:=Conveyor[cMEM];
    if (Conveyor[cWB]>=Length(Commands)) Then ProgramOver:=true;
    for n :=1 to 3 do
     varsWB[n]:=varsMEM[n];
    if (Conveyor[cWB]>0) and (Conveyor[cWB]<Length(Commands)) Then
    begin
      Command:=@Commands[Conveyor[cWB]];
      case Command.Command of
      cADD,cSUB,cMUL,cDIV,cAND,cOR,cXOR,cMOV:
        begin
          Registers[Command^.Operands[1]]:=varsWB[1];
        end;
      end;
    end;
  end
  else
  begin
    WBBusy:=1;
    Conveyor[cWB]:=0;
  end;
end;

procedure TfrmMain.AboutClick(Sender: TObject);
begin
  AboutBox.ShowModal;
end;

Procedure TfrmMain.CalculateCharacteristics;
var n,k,r:real;
begin
  n:=StrToInt(sgParameters.Cells[1,5]);
  k:=StrToInt(sgParameters.Cells[1,1]);
  if (n<>0) Then
  begin
    r:=n/k;
    sgParameters.Cells[1,6]:=FloatToStr(r);
  end;
end;

procedure TfrmMain.RunClick(Sender: TObject);
begin
  While not ProgramOver do DoTakt;

end;

procedure TfrmMain.DoCompileClick(Sender: TObject);
begin
  Compile;
end;

end.
